#include <conio.h>
#include <dos.h>
#include <stdio.h>
#include "sys.h"

#define  FILE_NAME  "AREMOTE.LOG"
 extern  FILE* f;

int kbdBuf[KBD_BUF_LEN];
int kbdI, kbdJ = 0;

void init_all()
{
    f = fopen(FILE_NAME, "w");
    printf("\n 㭨ᠫ쭮    ⮢ 孨\n"
           "    믮: ..줥, .., . 3538\n"
           "                       2005 .\n\n"
           "                     ࠢ:\n\n"
           "ESC            - 室  ணࠬ\n"
           "0..9           - ஢   \n"
           "Space (஡) -  <Reset>  \n"
           "Tab            -  ᬥ ᪫  \n"
           "+              -  /࠭ ᨣ  \n"
           "A..Z, a..z     - ᨣ 譥 ன⢠\n"
           "Enter          - ᨣ 砭  譥 ன⢠\n\n");
}

int next(int i)
{
    return (++i == KBD_BUF_LEN) ? 0 : i;
}

int prev(int i)
{
    return ((i == 0) ? KBD_BUF_LEN : i) - 1;
}

void wait_for_key()
{
    while (!kbhit());
    while (kbhit()) getch();
}

void message(const char *s)
{
    int i;
    printf("\r");
    for (i = 0; i < SPACES; i++) putch(' ');
    printf("\r%s ", s);
}

void say_ready()
{
    message(MSG_READY);
    wait_for_key();
}

void send(const int *signals)
{
    char s[MAX_SIGNALS];
    int i, x;
    for (i = 0; x = signals[i]; i++) s[i] = x;
    s[i] = 0;
    printf("\r");
    for (i = 0; i < SPACES; i++) printf(" ");
    printf("\rன  ᫠ ᨣ: \"%s\".   ... ", s);
    wait_for_key();
}

void getTime(TTime *_time)
{
    struct time t;
    gettime(&t);
    _time->h = t.ti_hour;
    _time->m = t.ti_min;
    _time->s = t.ti_sec;
}

int keypressed(int *key)
{
    int ch;
    checkKbdBuf();
    if (kbdI == kbdJ) return 0;
    ch = kbdBuf[kbdI];
    kbdI = next(kbdI);
    switch(ch)
    {
        case  27:                  // ESC
            *key = KEY_ESC;
            return 0;
        case  32:                  // Space
            *key = KEY_RESET;
            return 1;
        case   9:                  // Tab
            *key = KEY_SET_PAD;
            return 1;
        case '+':
            *key = KEY_RECORD;
            return 1;
    }
    if (ch >= '0' && ch <= '9')
    {
        *key = ch - '0';
        return 1;
    }
    kbdI = prev(kbdI);
    return 0;
}

int receive_signal(int *signal)
{
    int ch;
    checkKbdBuf();
    if (kbdI == kbdJ) return 0;
    ch = kbdBuf[kbdI];
    kbdI = next(kbdI);
    if (ch == 13)
    {
        *signal = STOP_SIGNAL;
        return 1;
    }
    if (ch >= 'A' && ch <= 'Z' || ch >= 'a' && ch <= 'z')
    {
        *signal = ch;
        return 1;
    }
    kbdI = prev(kbdI);
    return 0;
}

void checkKbdBuf()
{
    if (kbhit())
    {
        if (next(kbdJ) != kbdI)
        {
            int ch = getch();
            kbdBuf[kbdJ] = ch;
            kbdJ = next(kbdJ);
        }
        while (kbhit()) getch();
    }
}

void storeLog(int event, int y)
{
    char *events[5] = {
                        "砫 ࠡ",
                        " ",
                        "訫  ⠩",
                        "祭 ᨣ ",
                        "祭 ᨣ 砭"
                      };
    char *states[7] = {
                        "砫쭮 ﭨ",
                        "ࠡ稩 ०",
                        "० ࣮ᡥ०",
                        "롮 ᪫",
                        "० ",
                        " ᨣ",
                        "ᮮ饭  ࠭"
                      };
    fprintf(f, "室  ᮡ e%d (%s)  ﭨ %d (%s).\n",
               event, events[event], y, states[y]);
}