#ifndef __SYS
#define __SYS

#define  STOP_SIGNAL  '\n'

#define  NUM_KEYS     16                        // ᫮  
#define  NUM_PADS     NUM_KEYS                  // ᫮ ᪫
#define  MAX_SIGNALS  10                        // ᨬ ᨣ  

#define  KEY_RESET    (NUM_KEYS - 3)
#define  KEY_SET_PAD  (NUM_KEYS - 2)
#define  KEY_RECORD   (NUM_KEYS - 1)

#define  MSG_READY              "Ready for work. Press any key."
#define  MSG_WORK               "Waiting for command..."
#define  MSG_CHOOSE_PAD         "Choose layout..."
#define  MSG_PAD_NOT_CHOSEN     "Layout is not chosen in time."
#define  MSG_PRESS_KEY          "Press key for bind..."
#define  MSG_RECORD_TIME_IS_UP  "Nothing was pressed."
#define  MSG_LISTEN_TIME_IS_UP  "Can't catch signal."
#define  MSG_LISTEN             "Listening for signal..."
#define  MSG_KEY_BINDED         "Key has been binded."
#define  MSG_BUFFER_OVERFLOW    "Buffer overflow. Data is lost."
#define  MSG_BUFFER_IS_FULL     "Buffer's full. Pls, finish rec."

void init_all();
void message(const char *s);
void send(const int *signals);
int keypressed(int *key);
int receive_signal(int *signal);
void storeLog(int event, int y);

#endif