#ifndef __SYS
#define __SYS

#define  SPACES       79
#define  STOP_SIGNAL  -1
#define  KBD_BUF_LEN  16

#define  NUM_KEYS     16                        // ᫮  
#define  NUM_PADS     NUM_KEYS                  // ᫮ ᪫
#define  MAX_SIGNALS  10                        // ᨬ ᨣ  

#define  KEY_NOKEY    -2
#define  KEY_ESC      -1
#define  KEY_RESET    NUM_KEYS
#define  KEY_SET_PAD  (NUM_KEYS + 1)
#define  KEY_RECORD   (NUM_KEYS + 2)

#define  MSG_READY              "樠 襭.  ⮢  ࠡ.   ..."
#define  MSG_WORK               " ..."
#define  MSG_CHOOSE_PAD         "롥 ᪫..."
#define  MSG_PAD_NOT_CHOSEN     "६  롮  ᪫ ⥪."
#define  MSG_PRESS_KEY          "   ..."
#define  MSG_RECORD_TIME_IS_UP  "६   ⥪."
#define  MSG_LISTEN_TIME_IS_UP  "६  ᨣ ⥪."
#define  MSG_LISTEN             " ᨣ..."
#define  MSG_KEY_BINDED         " 樨஢   襩."
#define  MSG_BUFFER_OVERFLOW    " ᨣ ९.  ."
#define  MSG_BUFFER_IS_FULL     " ᨣ . ⮡ ࠭ , ⠭ ."


typedef struct { int h, m, s; } TTime;

void init_all();
void message(const char *s);
void send(const int *signals);
void getTime(TTime *time);
int keypressed(int *key);
int receive_signal(int *signal);
void checkKbdBuf();
void storeLog(int event, int y);

#endif