/******************************************************************************
                ()  "", -, , 2002.
                http://lmt.cs.ifmo.ru, tel.: +7-812-233-3096,
                mailto: lmt@d1.ifmo.ru

         䠩  ᢮ ࠭塞 ਬ஬ ࠡ
     ⠫᪨  ஬  祡  ⥭  SDK-1.1  
    몥   (  Keil  C    KEIL  ELEKTRONIK  GmbH)   
    ।祭  樨 ࠡ  ன⢮.
          ணࠬ          ࣠   ⥫쭮
    ஢       ᮤঠ   訡.          
    ⢥⢥    ଠ樨        ।
    ᫥⢨ ᯮ짮  ணࠬ      ⠢
    ணࠬ ஥⮢.
         䠩  ࣠  ,     
    ࠭  ᪨ 楫      ⠢  ᪨
    ணࠬ த⮢.
    

:       lcd.c
:     1.0.0
:      LAN
ᠭ:    樮 ணࠬ ᯥ祭  ⥭
            SDK-1.1.   ⠫᪨ ஬. 
             ᯮ  ࠡ  㭪樮 ⥫
            業ࠫ쭮     MAX3064 (3128) - max.c,
            max.h.

:
-------------------------------------------------------------------------------
N                        ᠭ   
-------------------------------------------------------------------------------
1 09.04.02  1.0.0   LAN     
******************************************************************************/
#include "lcd.h"    //ᠭ  (⠭)
#include "max.h"    //ᠭ ⮢  MAX3064 (3128)

/*----------------------------------------------------------------------------
            ६  䫠
 -----------------------------------------------------------------------------*/
static bit CurPosCtrl=1;    //᫥ ࠩ஬ ⥪饩 樨 
                            // (1 - ., 0 - 몫.)

//  .  , ⮫쪮 ᫨ CurPosCtrl = 1.
//६ ᯮ 㭪ﬨ LCD_Putch(), LCD_GotoXY()
static char cur_x=0;//0-15
static bit cur_y=0; //0/1


/*----------------------------------------------------------------------------
                    㭪樨
 -----------------------------------------------------------------------------*/

/**----------------------------------------------------------------------------
                        SwitchCurPosControl()
-------------------------------------------------------------------------------
祭/몫祭 ᫥ ⥪饩 樨 . ᫥ 祭
஫ ⥫쭮 ⠭ ⥪   (LCD_GotoXY()), .. 
祭 ६ cur_x  cur_y  ᮤঠ ࠢ 祭.

室:       bit o: o = 1 -  ஫
                   o = 0 - 몫 ஫
室:      
:  
----------------------------------------------------------------------------- */
void SwitchCurPosControl(bit o)
{
    CurPosCtrl=o;
}

/**----------------------------------------------------------------------------
                        Strobe()
-------------------------------------------------------------------------------
 ᨣ E 䥩 <->  ६   500 . ६
 ᨣ R/W  RS   㬥⮬ c 祭.

室:       char c -  1,2 । 祭 ᨣ R/W  RS:
                 1: 1 - R/W = 1 (⥭)
                       0 - R/W = 0 ()
                 2: 1 - RS = 1 ( ॣ  )
                       0 - RS = 0 ( ॣ  )
                 3:   ࠢ 1!
                祭 ⠫   ਭ  .

室:      
:  
----------------------------------------------------------------------------- */
void Strobe(char c)
{
unsigned int i;

    WriteMax(C_IND,c | 0x1);  //⠭ ஡ E
    WriteMax(C_IND,c & 0xFE); // ஡

    for (i=0;i<300;i++)continue; //প  ६ ᯮ  
                                 //(>1.59ms)
    
}

/**----------------------------------------------------------------------------
                        LCD_SwitchCursor()
-------------------------------------------------------------------------------
⠭ ० : 祭/몫祭 , ./몫. 

室:       bit cursor: 1 -  ,
                        0 - 몫 ;
            bit blink:  1 -  ,
                        0 - 몫 .

室:      
:  
----------------------------------------------------------------------------- */
void LCD_SwitchCursor(bit cursor, bit blink)
{
unsigned char i=0;

    WriteMax( DATA_IND, DISPLAY_CTRL |
                        DISPLAY_ON |
                        ((cursor)?CURSOR_ON:0) |
                        ((blink)?BLINK:0) );

    Strobe(0x8); //R/W = 0; RS = 0

}


/**----------------------------------------------------------------------------
                        LCD_Clear()
-------------------------------------------------------------------------------
⪠   ⠭ ⥪饩 樨   ᨬ ࢮ ப

室:       
室:      
:  
----------------------------------------------------------------------------- */
void LCD_Clear(void)
{
int i;

    WriteMax(DATA_IND, CLEAR);
    Strobe(0x8); //clear
    cur_x = 0;
    cur_y = 0;
//    for(i=0; i<1600; i++)continue;
}


/**----------------------------------------------------------------------------
                        InitLCD()
-------------------------------------------------------------------------------
樠 .

室:       
室:      
:  
----------------------------------------------------------------------------- */
void InitLCD(void)
{
unsigned short i;

    for(i=0; i<4000; i++)continue; // 祭  (>15 ᫥  
                                   //⠭)
//    cmd = 0x30;  //
    WriteMax(DATA_IND, FUNCTION_SET|EIGHT_BITS);
    Strobe(0x8);
    for(i=0; i<1500; i++)continue; //, ।ᬮ७ ⮪
                                   //樠樨 (>4.1)
//    cmd = 0x30;  //

    WriteMax(DATA_IND, FUNCTION_SET|EIGHT_BITS);
    Strobe(0x8);
    for(i=0; i<50; i++)continue;   //, ।ᬮ७ ⮪
                                   //樠樨 (>4.1)
//    cmd = 0x30;  //
    WriteMax(DATA_IND, FUNCTION_SET|EIGHT_BITS);
    Strobe(0x8);
//    for(i=0; i<100; i++)continue;

//    cmd = 0x38;  //
    WriteMax(DATA_IND, FUNCTION_SET|EIGHT_BITS|TWO_LINE);
    Strobe(0x8);

//    cmd = 0x08;  //
    WriteMax(DATA_IND, DISPLAY_CTRL); //Display off
    Strobe(0x8);

//    cmd = 0x01;  //
    WriteMax(DATA_IND, CLEAR); 
    Strobe(0x8);

//    for(i=0; i<1600; i++)continue;
    WriteMax(DATA_IND, ENTRY_MODE|INCR);
    Strobe(0x8);
//    cmd = 0x0F;  //Display ON
    WriteMax(DATA_IND, DISPLAY_CTRL|DISPLAY_ON); //Cursor OFF, Blinking OFF
    Strobe(0x8);
}

/**----------------------------------------------------------------------------
                        LCD_Putch()
-------------------------------------------------------------------------------
뢮  ⥪  ᨬ.   ।  ᨬ
 祭 䫠 CurPosCtrl: ᫨  ⠭,   ६ cur_x, cur_y
( ⮬  㢥稢   뢥 ᨬ);
᫨  襭,   ७ 㪠⥫  ( 㢥稢  뢮
ᨬ).

室:       char ch - 뢮 ᨬ
室:      
:  
----------------------------------------------------------------------------- */
void LCD_Putch(char ch)
{

    if(CurPosCtrl)
    {
        LCD_GotoXY(cur_x,cur_y);
        if(++cur_x>15)cur_x=0,cur_y=~cur_y;
    }

    WriteMax(DATA_IND,ch);
    Strobe(0xC); //R/W = 0, RS = 1 ()
}

/**----------------------------------------------------------------------------
                        LCD_GotoXY()
-------------------------------------------------------------------------------
⠭ ⥪饩 樨 . ࠭   ७ ६ ࠩ.

室:       uchar x -  ⮫ (樨  ப): 0..15.
            bit y -  ப: 0..1.
室:      
:  
----------------------------------------------------------------------------- */
void LCD_GotoXY(unsigned char x,bit y)
{
    WriteMax(DATA_IND,RAM_DD|(x+((y)?0x40:0)));
    Strobe(0x8); //set ram
    cur_x = x;
    cur_y = y;
}

/**----------------------------------------------------------------------------
                        LCD_Type()
-------------------------------------------------------------------------------
뢮 ASCIIZ-ப   稭  ⥪饩 樨.

室:       char *s - 㪠⥫  ப.
室:      
:  
----------------------------------------------------------------------------- */
void LCD_Type(char* s)
{
bit t = CurPosCtrl;

    SwitchCurPosControl(1);
    while(*s)
        LCD_Putch(*s++);

    SwitchCurPosControl(t);
}

