#include "hash.h"

int arr[NUM_PADS][NUM_KEYS];
enum bool used[NUM_PADS][NUM_KEYS];

int pad = 0;

void hash_init(void) 
{
	int i, j;
	for (i = 0; i < NUM_PADS; i++) {
		for (j = 0; j < NUM_KEYS; j++) {
			arr[i][j] = 0;
			used[i][j] = false;
        }
	}
}
void hash_change_pad(int new_pad) 
{
	pad = new_pad;
}

void hash_bind(int key, int signal)
{
	arr[pad][key] = signal;
	used[pad][key] = true;
}

int hash_get_pad(void) 
{
	return pad;
}

int hash_get(int key, enum bool* exists)
{
	*exists = used[pad][key];
	return arr[pad][key];
}
